using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Sincronizacion;
using Exferia_EntityFramework;
using Exferia_Formularios;
using Exferia_General;
using Exferia_HotelPuntoVenta._1_Datos;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using System.Windows.Forms;

namespace Exferia_HotelPuntoVenta._3_Vistas.Controladoras
{
    public class P_Camarero_Controladora
    {
        #region Variables Generales
        private P_Camarero g_frm_P_Camarero; //Variable que enlaza con la pantalla
        private PE_Esperando g_frm_PE_Esperando;//Pantalla de Espera, para cuando se ejecutan tareas pesadas como cargar, guardar, etc

        public bool g_bol_CampoCodigo_Numerico = false;

        //Clases de Negocio necesarias
        private HPV_Camareros_Datos g_obj_HPV_Camareros_Datos = new HPV_Camareros_Datos();

        //Modelo necesarios
        private HPV_Camareros g_mdl_HPV_Camareros = null;

        public bool g_bol_Termino_CargaDatos_Inicial = false;//Se utiliza para saber cuando se termina la carga de datos estaticos inciales

        //Tareea Asincrona de carga de datos
        private BackgroundWorker g_obj_TareaAsincrona_CargarDatos;

        //Tareea Asincrona de grabar de datos
        private BackgroundWorker g_obj_TareaAsincrona_GrabarDatos;
        private bool g_bol_GrabarDatos_TerminoCorrectamente = true;
        private bool g_bol_GrabarDatos_VolverListado = true;

        //Tareea Asincrona de borrar de datos
        private BackgroundWorker g_obj_TareaAsincrona_BorrarDatos;

        //Array de imagen
        public byte[] g_arr_Foto;
        public Image g_img_Foto;
        #endregion

        #region Constructor
        public P_Camarero_Controladora (P_Camarero _frm_P_Camarero)
        {
            g_frm_P_Camarero = _frm_P_Camarero;

            g_bol_Termino_CargaDatos_Inicial = true;
        }
        #endregion

        #region Vaciar Datos
        private void VaciarDatos()
        {
            //modelo
            g_mdl_HPV_Camareros = null;

            //codigo
            g_frm_P_Camarero.Exferia_TextBox_Codigo.Text = "";
            //nombre
            g_frm_P_Camarero.Exferia_TextBox_Nombre.Text = "";
            //nombre validacion
            g_frm_P_Camarero.Exferia_TextBox_Nombre_Validacion.Text = "";
            //clave validacion
            g_frm_P_Camarero.Exferia_TextBox_Clave_Validacion.Text = "";

            //Mostrar caracteres
            g_frm_P_Camarero.Exferia_CheckBox_MostrarCaracteres.Checked = false;

            //Fecha Alta
            g_frm_P_Camarero.Exferia_FechaSeleccion_FechaAlta.Exferia_FechaSeleccion_Fecha = "";
            //Fecha Baja
            g_frm_P_Camarero.Exferia_FechaSeleccion_FechaBaja.Exferia_FechaSeleccion_Fecha = "";

            //CamareroPerfil
            g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Id = -1;
            g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Codigo = "";
            g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Descripcion = "";
            g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_FechaBorrado = null;

            //Empleado/proveedor
            g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Id = -1;
            g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Codigo = "";
            g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Descripcion = "";
            g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_FechaBorrado = null;

            //Poner como Empleado
            g_frm_P_Camarero.Exferia_CheckBox_EsProveedor.Checked = false;

            //Imagen
            g_arr_Foto = null;
            g_img_Foto = null;
            g_frm_P_Camarero.PictureBox_Foto.Image = null;
            g_frm_P_Camarero.PictureBox_Foto.Tag = "";

            string[] str_Separador = new string[] { " [" };
            //Si ya hay valores de objeto, los elimino para rellenarlos de nuevo
            if (g_frm_P_Camarero.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None).Count() > 1)
            {
                g_frm_P_Camarero.P_Base_TituloPantalla = (g_frm_P_Camarero.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None))[0];
            }

            //Actualizar el Boton de Seleccion de pantalla ####################################################
            Variables.G_EMS_CONTROL_MENUSUPERIOR.Update_Texto_NombrePantalla(g_frm_P_Camarero.Tag.ToString());
            //#################################################################################################
        }
        #endregion

        #region BuscarCodigoSiguiente
        public INTERNO_ValorDevuelto_Modelo Buscar_CodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                HPV_Camareros obj_HPV_Camareros;

                string str_CodigoSiguiente = Datos_Generales.Buscar_CodigoSiguiente(nameof(HPV_Camareros),
                                                                                    nameof(obj_HPV_Camareros.codigo),
                                                                                    nameof(obj_HPV_Camareros.idEmpresa),
                                                                                    g_mdl_HPV_Camareros != null ? g_mdl_HPV_Camareros.idEmpresa : Datos_Generales.GEN_Empresas_Devolver_IdEmpresa_AGrabar(g_frm_P_Camarero.P_Base_ValoresGenerales.lng_idEmpresa, nameof(HPV_Camareros)),
                                                                                    true,
                                                                                    g_frm_P_Camarero.Exferia_TextBox_Codigo.Exferia_TextBox_MaxLength);

                if (!str_CodigoSiguiente.Equals("-1"))
                {
                    g_frm_P_Camarero.Exferia_TextBox_Codigo.Text = str_CodigoSiguiente;
                }
                else
                {
                    mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_CODIGOSIGUIENTE_LIMITEALCANZADO(g_frm_P_Camarero.Exferia_Label_Codigo.Text);
                }

            }
            catch (Control_Errores)
            {
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BUSCARCODIGOSIGUIENTE();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(Buscar_CodigoSiguiente));
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BUSCARCODIGOSIGUIENTE();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Comprobacion de cambios, para  grabar o no antes de salir o cambiar de registro
        public bool ComprobarCambios()
        {
            if (g_frm_P_Camarero.P_Base_SeModificoDatosPantalla)
            {
                if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_GENERAL_PREGUNTA_GUARDARCAMBIOS()))
                {
                    GrabarDatos(false);

                    //Te quedas espernado a que termine la tarea asincrona de grabar
                    while (g_obj_TareaAsincrona_GrabarDatos.IsBusy)
                        Application.DoEvents();

                    return g_bol_GrabarDatos_TerminoCorrectamente;
                }
            }
            return true;
        }
        #endregion

        #region Cargar Datos
        public void RecargarDatos()
        {
            try
            {
                //Bloquear el formulario para que no se pueda hacer nada hasta que termine
                g_frm_P_Camarero.Enabled = false;

                //Mostrar la pantalla de espera
                g_frm_PE_Esperando = new PE_Esperando();

                // Si la tarea asincrona esta en marcha la paro
                if (g_obj_TareaAsincrona_CargarDatos != null)
                {
                    while (g_obj_TareaAsincrona_CargarDatos.IsBusy)
                        Application.DoEvents();

                    //Vaciar
                    VaciarDatos();
                }
                else
                {
                    g_obj_TareaAsincrona_CargarDatos = new BackgroundWorker();
                    g_obj_TareaAsincrona_CargarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_CargarDatos_DoWork);
                    g_obj_TareaAsincrona_CargarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_CargarDatos_Completed);
                    g_obj_TareaAsincrona_CargarDatos.WorkerReportsProgress = false;
                }

                //(Tarea Asincrona) Cargar Datos ##################################################################
                g_obj_TareaAsincrona_CargarDatos.RunWorkerAsync();
                //#################################################################################################

                g_frm_PE_Esperando.ShowDialog();
            }
            catch (Exception ex)
            {
                g_frm_P_Camarero.Enabled = true;

                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }

                throw new Control_Errores(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA(), ex, nameof(P_Camarero_Controladora) + "/" + nameof(RecargarDatos), true);
            }
        }

        private void TareaAsincrona_CargarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Cargar Valores
                if (CargarDatos(g_frm_P_Camarero.P_Base_id) == false)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
                }
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_DoWork));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_DoWork));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_CargarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            //Desbloquear el Formulario
            g_frm_P_Camarero.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);
                    g_frm_P_Camarero.Salir_P_Base();
                }
                else
                {
                    //PictureBox
                    if (g_img_Foto != null)
                    {
                        g_frm_P_Camarero.PictureBox_Foto.Image = g_img_Foto;
                        Funciones.PictureBox_RedimencionarImagen(g_frm_P_Camarero.PictureBox_Foto, g_frm_P_Camarero.PictureBox_Foto.Image);
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_Completed));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());

                g_frm_P_Camarero.Salir_P_Base();
            }
            finally
            {

                //Hacemos foco al primer control.
                g_frm_P_Camarero.Exferia_TextBox_Codigo.Exferia_TextBox_Foco();
            }
        }

        public bool CargarDatos(long _lng_id)
        {
            Encriptador obj_Encriptador = new Encriptador();
            bool bol_ValorDevuelto = true;

            try
            {
                g_mdl_HPV_Camareros = g_obj_HPV_Camareros_Datos.Obtener(_lng_id);

                //Si no es nulo cargo los datos
                if(g_mdl_HPV_Camareros != null)
                {
                    //Paginador ................................................................................
                    if (g_frm_P_Camarero.P_Base_PantallaOrigen != null &&
                        g_frm_P_Camarero.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                        g_frm_P_Camarero.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                    {
                        long lng_id_ParaPaginacion = g_mdl_HPV_Camareros.id;
                        int int_PaginaDelObjeto = g_frm_P_Camarero.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.IndexOf(g_frm_P_Camarero.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Where(n => n.ID.Equals(lng_id_ParaPaginacion)).FirstOrDefault());

                        g_frm_P_Camarero.g_obj_Funciones_Paginador.SetPaginaActual(int_PaginaDelObjeto);
                        // Asignando al paginador la pagina actual.
                        g_frm_P_Camarero.Exferia_Paginador_Camarero.PaginaActual = g_frm_P_Camarero.g_obj_Funciones_Paginador.GetPaginaActual();
                    }
                    //...........................................................................................

                    //Codigo
                    g_frm_P_Camarero.Exferia_TextBox_Codigo.Text = g_mdl_HPV_Camareros.codigo;

                    //Nombre
                    g_frm_P_Camarero.Exferia_TextBox_Nombre.Text = g_mdl_HPV_Camareros.nombre;

                    //Nombre Validacion
                    g_frm_P_Camarero.Exferia_TextBox_Nombre_Validacion.Text = g_mdl_HPV_Camareros.validacion_Nombre;

                    //Clave Validacion
                    if (g_mdl_HPV_Camareros.validacion_Clave.Trim().Length > 0)
                    {
                        g_frm_P_Camarero.Exferia_TextBox_Clave_Validacion.Text = obj_Encriptador.Desencriptar(g_mdl_HPV_Camareros.validacion_Clave);
                    }

                    //Fecha Alta
                    g_frm_P_Camarero.Exferia_FechaSeleccion_FechaAlta.Exferia_FechaSeleccion_Fecha = g_mdl_HPV_Camareros.fechaAlta.ToString("dd/MM/yyyy");

                    //FechaBaja
                    if(g_mdl_HPV_Camareros.fechaBaja != null)
                    {
                        g_frm_P_Camarero.Exferia_FechaSeleccion_FechaBaja.Exferia_FechaSeleccion_Fecha = g_mdl_HPV_Camareros.fechaBaja.Value.ToString("dd/MM/yyyy");
                    }

                    //EmpleadoProveedor
                    if(g_mdl_HPV_Camareros.MAE_Empleados != null)
                    {
                        g_frm_P_Camarero.Exferia_CheckBox_EsProveedor.Checked = false;

                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Id = g_mdl_HPV_Camareros.MAE_Empleados.id;
                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Codigo = g_mdl_HPV_Camareros.MAE_Empleados.codigo;
                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Descripcion = g_mdl_HPV_Camareros.MAE_Empleados.nombre;
                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_FechaBorrado = g_mdl_HPV_Camareros.MAE_Empleados.fechaBorrado;
                    }
                    //Proveedor
                    else if(g_mdl_HPV_Camareros.MAE_Proveedores != null)
                    {
                        g_frm_P_Camarero.Exferia_CheckBox_EsProveedor.Checked = true;

                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Id = g_mdl_HPV_Camareros.MAE_Proveedores.id;
                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Codigo = g_mdl_HPV_Camareros.MAE_Proveedores.codigo;
                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Descripcion = g_mdl_HPV_Camareros.MAE_Proveedores.razonSocial;
                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_FechaBorrado = g_mdl_HPV_Camareros.MAE_Proveedores.fechaBorrado;
                    }

                    //CamareroPerfil
                    if (g_mdl_HPV_Camareros.HPV_CamarerosPerfiles != null)
                    {
                        g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Id = g_mdl_HPV_Camareros.HPV_CamarerosPerfiles.id;
                        g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Codigo = g_mdl_HPV_Camareros.HPV_CamarerosPerfiles.codigo;
                        g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Descripcion = g_mdl_HPV_Camareros.HPV_CamarerosPerfiles.descripcion;
                        g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_FechaBorrado = g_mdl_HPV_Camareros.HPV_CamarerosPerfiles.fechaBorrado;
                    }
                    else 
                    {
                        g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Id = -1;
                        g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Codigo = "";
                        g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Descripcion = "";
                        g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_FechaBorrado = null;
                    }

                    //Foto
                    if (g_mdl_HPV_Camareros.foto != null)
                    {
                        g_arr_Foto = g_mdl_HPV_Camareros.foto;
                        g_img_Foto = Funciones.Convertir_Arraybytes_Image(g_mdl_HPV_Camareros.foto);
                    }

                    // Mostrar Campo en el Titulo de mantenimiento
                    string str_MenuSuperior_Codigo = "";
                    if (g_frm_P_Camarero.g_mdl_PRV_OpcionesDetalle != null &&
                        g_frm_P_Camarero.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento != null &&
                        g_frm_P_Camarero.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento.Trim().Length > 0)
                    {
                        //Obtener el Array de Campos
                        string[] arr_Campos = g_frm_P_Camarero.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento.Split(new Char[] { ',' });
                        string str_ValorAMostrarFinal = "";


                        string[] str_Separador = new string[] { " [" };
                        //Si ya hay valores de objeto, los elimino para rellenarlos de nuevo
                        if (g_frm_P_Camarero.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None).Count() > 1)
                        {
                            g_frm_P_Camarero.P_Base_TituloPantalla = (g_frm_P_Camarero.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None))[0];
                        }

                        dynamic dnm_Objeto = g_mdl_HPV_Camareros;
                        foreach (string str_campo in arr_Campos)
                        {
                            var Valor = dnm_Objeto.GetType().GetProperty(str_campo).GetValue(dnm_Objeto, null);
                            if (Valor != null)
                            {
                                str_ValorAMostrarFinal += " " + Valor;
                            }

                            // codigo
                            if (str_campo.Equals(nameof(g_mdl_HPV_Camareros.codigo)))
                            {
                                str_MenuSuperior_Codigo = g_mdl_HPV_Camareros.codigo;
                            }
                        }
                        if (str_ValorAMostrarFinal != "")
                        {
                            g_frm_P_Camarero.P_Base_TituloPantalla += " [" + str_ValorAMostrarFinal + "] -Modificar";
                        }
                    }
                    //Actualizar el Boton de Seleccion de pantalla ####################################################
                    Variables.G_EMS_CONTROL_MENUSUPERIOR.Add_Texto_NombrePantalla_Descripciones(g_frm_P_Camarero.Tag.ToString(), str_MenuSuperior_Codigo);
                    //#################################################################################################

                    g_frm_P_Camarero.P_Base_SeModificoDatosPantalla = false;
                }
            }
            catch (Control_Errores)
            {
                bol_ValorDevuelto = false;
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(CargarDatos));
                bol_ValorDevuelto = false;
            }

            return bol_ValorDevuelto;
        }
        #endregion

        #region Grabar Datos
        public void GrabarDatos(bool _bol_VolverAlListado)
        {
            try
            {
                g_bol_GrabarDatos_VolverListado = _bol_VolverAlListado;

                g_bol_GrabarDatos_TerminoCorrectamente = true;

                g_frm_P_Camarero.Enabled = false;
                g_frm_PE_Esperando = new PE_Esperando(Mensajes.G_STR_ESPERANDO_GRABANDODATOS());

                g_obj_TareaAsincrona_GrabarDatos = new BackgroundWorker();
                g_obj_TareaAsincrona_GrabarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_GrabarDatos_DoWork);
                g_obj_TareaAsincrona_GrabarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_GrabarDatos_Completed);
                g_obj_TareaAsincrona_GrabarDatos.RunWorkerAsync();

                g_frm_PE_Esperando.ShowDialog();
            }
            catch (Exception ex)
            {
                g_bol_GrabarDatos_TerminoCorrectamente = false;
                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }
                g_frm_P_Camarero.Enabled = true;

                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(GrabarDatos));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA());
            }
        }

        private void TareaAsincrona_GrabarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Validar Primero
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_VALIDACION = ValidarDatos();
                if (mdl_ValorDevuelto_Modelo_VALIDACION.TodoCorrecto)
                {
                    mdl_ValorDevuelto_Modelo = GrabarDatos_Final();
                }
                else
                {
                    mdl_ValorDevuelto_Modelo = mdl_ValorDevuelto_Modelo_VALIDACION;
                }
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_GrabarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            g_frm_P_Camarero.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);

                        //Poner el Foco en el objeto que tuvoel problema en validar
                        if (mdl_ValorDevuelto_Modelo_Resultado.Objeto != null)
                        {
                            Funciones.Poner_Foco_Objeto(g_frm_P_Camarero, mdl_ValorDevuelto_Modelo_Resultado.Objeto);
                        }
                    }

                    g_bol_GrabarDatos_TerminoCorrectamente = false;
                }
                else
                {
                    // Devolver al Listado el Row Añadido/Modificado
                    if (g_frm_P_Camarero.P_Base_PantallaOrigen != null)
                    {
                        g_frm_P_Camarero.P_Base_PantallaOrigen.P_Base_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }
                    else if (g_frm_P_Camarero.P_Base_F3Origen != null)
                    {
                        g_frm_P_Camarero.P_Base_F3Origen.Exferia_F3_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }

                    if (g_bol_GrabarDatos_VolverListado)
                    {
                        g_frm_P_Camarero.P_Base_SeModificoDatosPantalla = false;
                        g_frm_P_Camarero.Salir_P_Base();
                    }

                    g_frm_P_Camarero.P_Base_SeModificoDatosPantalla = false;

                    //Si fue todo correcto desbloqueo el paginador y el boton de borrar y Recargo la pantalla
                    g_frm_P_Camarero.Exferia_Button_Borrar.Enabled = true;
                    g_frm_P_Camarero.Exferia_Paginador_Camarero.Visible = true;
                    RecargarDatos();
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_Completed));
            }
        }

        public INTERNO_ValorDevuelto_Modelo ValidarDatos()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                //Si el codigo esta vacio y se intenta buscar el ultimo numerico y llego al limite de base de datos
                if (g_frm_P_Camarero.Exferia_TextBox_Codigo.Text.Trim().Length == 0)
                {
                    INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = Buscar_CodigoSiguiente();

                    if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false)
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = mdl_INTERNO_ValorDevuelto_Modelo.Mensaje;
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_TextBox_Codigo;
                    }
                }

                // El codigo no puede estar Repetido
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    string str_Codigo = g_frm_P_Camarero.Exferia_TextBox_Codigo.Text.Trim();
                    if (g_bol_CampoCodigo_Numerico)
                    {
                        int int_Codigo = int.Parse(str_Codigo);
                        str_Codigo = int_Codigo.ToString();
                    }

                    if (Datos_Generales.Buscar_CodigoRepetido(nameof(HPV_Camareros), nameof(HPV_Camareros.codigo), str_Codigo, nameof(HPV_Camareros.id), (g_mdl_HPV_Camareros != null ? g_mdl_HPV_Camareros.id : -1), nameof(HPV_Camareros.idEmpresa), g_frm_P_Camarero.P_Base_ValoresGenerales.lng_idEmpresa, true))
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_REPETIDO(g_frm_P_Camarero.Exferia_Label_Codigo.Text);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_TextBox_Codigo;
                    }
                }

                // El nombre no puede estar vacío
                if ((mdl_ValorDevuelto_Modelo.TodoCorrecto) && (g_frm_P_Camarero.Exferia_TextBox_Nombre.Text.Trim().Length == 0))
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_Camarero.Exferia_Label_Nombre.Text);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_TextBox_Nombre;
                }

                // La fecha de alta no puede estar vacia y debe ser correcta
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    int int_fechaAlta_Respuesta = Funciones.Fecha_Validacion(g_frm_P_Camarero.Exferia_FechaSeleccion_FechaAlta.Exferia_FechaSeleccion_Fecha.Trim(' ', '/'));

                    if (int_fechaAlta_Respuesta == 1)//Vacia
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_Camarero.Exferia_FechaSeleccion_FechaAlta.Exferia_FechaSeleccion_Descripcion);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_FechaSeleccion_FechaAlta;
                    }
                    else if (int_fechaAlta_Respuesta == 2)//Incorrecta
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_FECHA_INCORRECTA(g_frm_P_Camarero.Exferia_FechaSeleccion_FechaAlta.Exferia_FechaSeleccion_Descripcion);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_FechaSeleccion_FechaAlta;
                    }
                }

                // La fecha de baja, si no esta vacio, debe ser correcta. (mensaje de vacio se queda vacio para que no controle el error)
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    int int_fechaAlta_Respuesta = Funciones.Fecha_Validacion(g_frm_P_Camarero.Exferia_FechaSeleccion_FechaBaja.Exferia_FechaSeleccion_Fecha.Trim(' ', '/'));
                    if (int_fechaAlta_Respuesta == 2)//Incorrecta
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_FECHA_INCORRECTA(g_frm_P_Camarero.Exferia_FechaSeleccion_FechaBaja.Exferia_FechaSeleccion_Descripcion);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_FechaSeleccion_FechaBaja;
                    }
                }

                //Ver si esta checkeado el empleado, tiene que tener unn empleado
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    // El empleado o proveedor no puede estar Vacio (Obligatorio)
                    if (g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Codigo.Trim().Length == 0 &&
                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Descripcion.Trim().Length == 0)
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Titulo);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                    }

                    // Si hay empleado o proveedor validar que es Correcta
                    if (mdl_ValorDevuelto_Modelo.TodoCorrecto && (g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Codigo.Trim().Length != 0 ||
                        g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Descripcion.Trim().Length != 0) && g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Id == -1)
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_F3_INCORRECTO(g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Titulo);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                    }
                }

                // El perfil no puede estar Vacio (Obligatorio)
                if (g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Codigo.Trim().Length == 0 &&
                    g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Descripcion.Trim().Length == 0)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                // Si hay perfil validar que es Correcta
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && (g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Codigo.Trim().Length != 0 ||
                    g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Descripcion.Trim().Length != 0) && g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Id == -1)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_F3_INCORRECTO(g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_VALIDARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(ValidarDatos));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_VALIDARDATOSPANTALLA();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        private INTERNO_ValorDevuelto_Modelo GrabarDatos_Final()
        {
            Encriptador obj_Encriptador = new Encriptador();
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            //Iniciar transaccion
            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    DateTime? dtt_fechaNula = null;

                    HPV_Camareros mdl_HPV_Camareros = new HPV_Camareros();
                    mdl_HPV_Camareros.id = g_mdl_HPV_Camareros != null ? g_mdl_HPV_Camareros.id : -1;

                    //Asignar el idEmpresa...........................................................................................
                    if ((g_mdl_HPV_Camareros != null ? g_mdl_HPV_Camareros.idEmpresa : -1) != -1)
                    {
                        mdl_HPV_Camareros.idEmpresa = g_mdl_HPV_Camareros.idEmpresa;
                    }
                    else
                    {
                        //Buscar el idEmpresa que Corresponda
                        mdl_HPV_Camareros.idEmpresa = Datos_Generales.GEN_Empresas_Devolver_IdEmpresa_AGrabar(g_frm_P_Camarero.P_Base_ValoresGenerales.lng_idEmpresa, nameof(HPV_Camareros));
                    }

                    // Codigo
                    mdl_HPV_Camareros.codigo = g_frm_P_Camarero.Exferia_TextBox_Codigo.Text.Trim();

                    // Nombre
                    mdl_HPV_Camareros.nombre = g_frm_P_Camarero.Exferia_TextBox_Nombre.Text.Trim();

                    //Nombre Validacion
                    mdl_HPV_Camareros.validacion_Nombre = g_frm_P_Camarero.Exferia_TextBox_Nombre_Validacion.Text.Trim();

                    //Clave Validacion
                    if (g_frm_P_Camarero.Exferia_TextBox_Clave_Validacion.Text.Trim().Length > 0)
                    {
                        mdl_HPV_Camareros.validacion_Clave = obj_Encriptador.Encriptar(g_frm_P_Camarero.Exferia_TextBox_Clave_Validacion.Text.Trim());
                    }
                    else
                    {
                        mdl_HPV_Camareros.validacion_Clave = "";
                    }

                    // Fecha Alta
                    mdl_HPV_Camareros.fechaAlta = DateTime.ParseExact(g_frm_P_Camarero.Exferia_FechaSeleccion_FechaAlta.Exferia_FechaSeleccion_Fecha, "dd/MM/yyyy", CultureInfo.InvariantCulture);

                    //Fecha baja
                    mdl_HPV_Camareros.fechaBaja = g_frm_P_Camarero.Exferia_FechaSeleccion_FechaBaja.Exferia_FechaSeleccion_Fecha.Trim(' ', '/') != "" ? DateTime.ParseExact(g_frm_P_Camarero.Exferia_FechaSeleccion_FechaBaja.Exferia_FechaSeleccion_Fecha, "dd/MM/yyyy", CultureInfo.InvariantCulture) : dtt_fechaNula;

                    //Proveedor
                    if(g_frm_P_Camarero.Exferia_CheckBox_EsProveedor.Checked)
                    {
                        //idEmpleado
                        mdl_HPV_Camareros.idEmpleado = null;
                        //idProveedor
                        mdl_HPV_Camareros.idProveedor = g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Id;
                    }
                    //Empleado
                    else
                    {
                        //idEmpleado
                        mdl_HPV_Camareros.idEmpleado = g_frm_P_Camarero.Exferia_F3_EmpleadoProveedor.Exferia_F3_Id; 
                        //idProveedor
                        mdl_HPV_Camareros.idProveedor = null;
                    }

                    //idCamareroPerfil
                    mdl_HPV_Camareros.idCamareroPerfil = g_frm_P_Camarero.Exferia_F3_Perfil.Exferia_F3_Id;
                    

                    //Foto
                    if (g_img_Foto != null )
                    {
                        mdl_HPV_Camareros.foto = Funciones.Convertir_Image_Arraybytes(g_img_Foto);
                    }
                    else
                    {
                        mdl_HPV_Camareros.foto = null;
                    }

                    // Se graba el modelo ya relleno.
                    mdl_ValorDevuelto_Modelo = g_obj_HPV_Camareros_Datos.Grabar(mdl_HPV_Camareros);

                    long lng_idCamarero = -1;
                    if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                    {
                        transaccion_SQL.Complete();

                        lng_idCamarero = mdl_ValorDevuelto_Modelo.Id;
                    }

                    //Termino Transaccion
                    transaccion_SQL.Dispose();

                    if(mdl_ValorDevuelto_Modelo.TodoCorrecto)
                    {
                        //Obtener el modelo que se acaba de grabar
                        g_mdl_HPV_Camareros = g_obj_HPV_Camareros_Datos.Obtener(lng_idCamarero);
                        g_frm_P_Camarero.P_Base_id = lng_idCamarero;


                        #region SINCRONIZACION PARA TERMINALES
                        Sincronizar_Registros obj_Sincronizar_Registros = new Sincronizar_Registros();

                        //HPV_Camareros
                        obj_Sincronizar_Registros.Sincronizar_Actualizar(new Sincronizar_Actualizar_Modelo(g_mdl_HPV_Camareros,
                                                                                                            g_frm_P_Camarero.P_Base_ValoresGenerales.lng_idEmpresa,
                                                                                                            nameof(HPV_Camareros)));
                        #endregion


                    }
                }
                catch (Control_Errores)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
                }
                catch (Exception ex)
                {
                    Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(GrabarDatos_Final));
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
                }
                finally
                {
                    //Termino Transaccion
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar Datos
        public void BorrarDatos()
        {
            try
            {
                // Preguntar si esta Seguro de Borrar
                if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_GENERAL_PREGUNTA_BORRAR()))
                {
                    g_frm_P_Camarero.Enabled = false;
                    g_frm_PE_Esperando = new PE_Esperando(Mensajes.G_STR_ESPERANDO_BORRANDODATOS());

                    g_obj_TareaAsincrona_BorrarDatos = new BackgroundWorker();
                    g_obj_TareaAsincrona_BorrarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_BorrarDatos_DoWork);
                    g_obj_TareaAsincrona_BorrarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_BorrarDatos_Completed);
                    g_obj_TareaAsincrona_BorrarDatos.RunWorkerAsync();

                    g_frm_PE_Esperando.ShowDialog();
                }
            }
            catch (Exception ex)
            {
                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }

                g_frm_P_Camarero.Enabled = true;

                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(BorrarDatos));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA());
            }
        }

        private void TareaAsincrona_BorrarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Borrar 
                mdl_ValorDevuelto_Modelo = BorrarDatos_Final();
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_BorrarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            g_frm_P_Camarero.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);
                    }
                }
                else
                {
                    // Devolver al Listado el Row Borrar
                    if (g_frm_P_Camarero.P_Base_PantallaOrigen != null)
                    {
                        g_frm_P_Camarero.P_Base_PantallaOrigen.P_Base_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }
                    else if (g_frm_P_Camarero.P_Base_F3Origen != null)
                    {
                        g_frm_P_Camarero.P_Base_F3Origen.Exferia_F3_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }

                    g_frm_P_Camarero.P_Base_SeModificoDatosPantalla = false;
                    g_frm_P_Camarero.Salir_P_Base();
                    
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Camarero_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_Completed));
            }
        }
        private INTERNO_ValorDevuelto_Modelo BorrarDatos_Final()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();

            try
            {
                mdl_INTERNO_ValorDevuelto_Modelo = g_obj_HPV_Camareros_Datos.Borrar(g_mdl_HPV_Camareros != null ? g_mdl_HPV_Camareros.id : -1);

                if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    #region SINCRONIZACION PARA TERMINALES
                    Sincronizar_Registros obj_Sincronizar_Registros = new Sincronizar_Registros();

                    //HPV_Camareros
                    obj_Sincronizar_Registros.Sincronizar_Borrar(new Sincronizar_Borrar_Modelo(g_mdl_HPV_Camareros.id.ToString(),
                                                                                                g_frm_P_Camarero.P_Base_ValoresGenerales.lng_idEmpresa,
                                                                                                nameof(HPV_Camareros)));

                    #endregion
                }


            }
            catch (Control_Errores)
            {
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Camarero_Controladora) + "/" + nameof(BorrarDatos_Final));
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }



            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        #endregion
    }
}
